import json
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import statsmodels.api as sm
from statsmodels.graphics.tsaplots import plot_acf,plot_pacf
import os

#get the json data and transfer to time series
f = open('2.txt','r')
for line in f:
    data = json.loads(line)
    for key in data:
        for k in data[key]:
            if k == "view_count":
                rdata = data[key][k]
rdata = np.array(rdata,dtype='float')
ts = pd.Series(rdata[:200])
s = pd.Series(rdata)
s.plot()
ts.index = pd.Index(sm.tsa.datetools.dates_from_range('2001','2200'))
print(ts)
#plt.rcParams['font.sans-serif'] = ['SimHei']
plt.rcParams['axes.unicode_minus'] = False

fig = plt.figure(figsize=  (12,8))
ax1 = fig.add_subplot(211)
fig = plot_acf(ts,lags=40,ax = ax1)
ax2 = fig.add_subplot(212)
fig = plot_pacf(ts,lags=40,ax=ax2)
plt.show()
#auto correlation
#adf
from statsmodels.tsa.stattools import adfuller as ADF
print(u'ADF Result:',ADF(ts))
#white noise
from statsmodels.stats.diagnostic import acorr_ljungbox
print(u'white noise result:',acorr_ljungbox(s,lags=1))


#arima, ar, ma model
from statsmodels.tsa.ar_model import AR
from statsmodels.tsa.arima_model import ARMA,ARIMA

#p,q= bic_matrix.stack().idxmin()
#print(u'minimun of p , q : %s, %s', p , q)
#model = ARMA(s,(1,1)).fit()
bic_matrix = []


for p in range(10):
    tmp = []
    for q in range(10):
        try:
            tmp.append(ARMA(ts,(p,q)).fit().bic)
        except:
            tmp.append(None)
    bic_matrix.append(tmp)
bic_matrix = pd.DataFrame(bic_matrix)
p,q = bic_matrix.stack().idxmin()
print(u'minimum of p , q : %s, %s' %(p,q))


model = ARMA(ts,(3,2)).fit()

predata = model.predict('2150','2200')
print(predata)
fig,ax = plt.subplots(figsize=(12,8))
ax = ts.ix['2001':].plot(ax=ax)
predata.plot(ax=ax)
plt.show()

